#!/usr/bin/python
import math
import random
import os
import time
import sys

#################################
# Programm zum Spiel des Lebens #
#################################

def clearmat(a,n):
# setzt die n x n - Matrix a auf 0
   for i in range(n+2):
      for j in range(n+2):
         a[i][j]=0

def printmat(a,n):
# druckt den Zustand der n x n - Matrix a so aus, dass tote Zellen 
# (d.h. a(i,j)=0) durch einen Punkt, lebende durch "0" dargestellt 
# werden
   for i in range(1,n+1):
      for j in range(1,n+1):
         if a[i][j]==0:
            print ".",
         else:
            print "0",
      print

def evalmat(a,b,n):
# berechnet fuer alle Zellen des Spielfeldes die Anzahl der lebenden 
# Nachbarzellen und speichert diese Information in der Matrix b
   for i in range(1,n+1):
      for j in range(1,n+1):
         b[i][j] = a[i-1][j]+a[i+1][j]+a[i][j-1]+a[i][j+1]\
                    +a[i-1][j-1]+a[i-1][j+1]+a[i+1][j-1]+a[i+1][j+1]

def setmat(a,b,n):
# berechnet die neue Generation von Zellen
   for i in range(1,n+1):
      for j in range(1,n+1):
         if a[i][j]==0 and b[i][j]==3:
            a[i][j]=1
         elif a[i][j]==1 and (b[i][j]<0 or b[i][j]>3):
            a[i][j]=0
         elif a[i][j]==1 and (b[i][j]==2 or b[i][j]==3):
            a[i][j]=1
         else:
            a[i][j]=0

#################
# HAUPTPROGRAMM #
#################

n=input("Bitte Groesse des Spielfeldes angeben (z.B. 40):  ")
ngen=input(" Bitte Anzahl der Generationen eingeben (z.B. 200) :  ")
# Die Matrizen a und b werden um einen aeusseren Rand vergroessert,
# weil sich dann die Berechnung der neuen Zellgeneration am Rand
# erheblich vereinfacht. (Ansonsten muessten in den Randzellen
# Fallunterscheidungen durchgefuehrt werden, weil Anzahl und Lage
# der Nachbarzellen an den Raendern unterschiedlich sind).
a=range(n+2)
b=range(n+2)
for i in range(n+2):
   a[i]=range(n+2)
   b[i]=range(n+2)
# Belege alle Elemente der Matrizen a und b mit "0"
clearmat(a,n)
clearmat(b,n)
# Initialisiere die Matrix a im Innern zufaellig mit lebenden ("1")
# und toten ("0") Zellen
for i in range(1,n+1):
   for j in range(1,n+1):
      a[i][j]=random.randint(0,1)
# fuer linux oder unix Systeme bitte den folgenden Befehl aktivieren
#os.system("clear")
os.system("CLS")
# drucke den Zustand der Matrix a aus
printmat(a,n)
for it in range(ngen):
   # setze matrix b auf "0" zurueck
   clearmat(b,n)
   # berechne die Anzahl lebender Nachbarzellen in der Matrix a und 
   # speichere diese Information in der Matrix b
   evalmat(a,b,n)
   # berechne die naechste Generation von Zellen
   setmat(a,b,n)
   # loesche den aktuellen Inhalt der Ausgabe
   # fuer linux oder unix Systeme bitte den folgenden Befehl aktivieren
   # os.system("clear")
   os.system("CLS")
   print
   printmat(a,n)
   print "Generation: ", it+1
   time.sleep(0.5)
sys.stdin.readline()
